Index: trunk/expressoMail1_2/controller.php
===================================================================
--- trunk/expressoMail1_2/controller.php	(revision 1738)
+++ trunk/expressoMail1_2/controller.php	(revision 5134)
@@ -8,4 +8,5 @@
 }
 require_once '../header.session.inc.php';
+require_once '../API/class.servicelocator.php';
 
 	//	Explode action from cExecuteForm function
@@ -16,15 +17,18 @@
 			$array_files = array(); 		
  			for($idx = 1; $idx <= $count_files; $idx++) { 		
- 				if($_FILES['file_'.$idx] && !$_FILES['file_'.$idx]['error'])
+ 				if(array_key_exists('file_'.$idx , $_FILES) && $_FILES['file_'.$idx] && !$_FILES['file_'.$idx]['error'])
  					$array_files[] = $_FILES['file_'.$idx]; 					 
  			}
  			$_POST['FILES'] = $array_files;
  		} 		  		
- 		list($app,$class,$method) = explode('.',@$_POST['_action']);
+		$get_p = explode('.',@$_POST['_action']);
+
  		$cExecuteFormReturn = true;
  	}
  	//	Explode action from cExecute function
- 	else if($_GET['action'])
-		list($app,$class,$method) = explode('.',@$_GET['action']);
+ 	else if(array_key_exists('action', $_GET))
+			$get_p = explode('.',@$_GET['action']);
+			
+
 	// NO ACTION
 	else
@@ -32,13 +36,13 @@
 	
 	// Load dinamically class file.
-	if($app == '$this')
-		$filename = 'inc/class.'.$class.'.inc.php';
+	if($get_p[0] == '$this')
+		$filename = 'inc/class.'.$get_p[1].'.inc.php';
 	else
-		$filename = '../'.$app.'/inc/class.'.$class.'.inc.php';
+		$filename = '../'.$get_p[0].'/inc/class.'.$get_p[1].'.inc.php';
 		
 	include_once($filename);	
 	
 	// Create new Object  (class loaded).	
-	$obj = new $class;
+	$obj = new $get_p[1];
 	
 	// Prepare parameters for execution.	
@@ -60,12 +64,15 @@
 	// if params is not empty, then class method with parameters.	
 	if($params)
-		$result = $obj -> $method($params);
+		$result = $obj -> $get_p[2]($params);
 	else 		
-		$result = $obj -> $method();
+		$result = $obj -> $get_p[2]();
 		
 	// Return result serialized.	
 	
 
-	if(!$cExecuteFormReturn)
+	if(!$cExecuteFormReturn /*&& (!$_REQUEST['isPost'])*/ )
+		if(array_key_exists(3,$get_p))
+			echo $result;
+		else
 		echo serialize($result);
 	else
Index: trunk/expressoMail1_2/inc/class.db_functions.inc.php
===================================================================
--- trunk/expressoMail1_2/inc/class.db_functions.inc.php	(revision 3018)
+++ trunk/expressoMail1_2/inc/class.db_functions.inc.php	(revision 5134)
@@ -210,7 +210,6 @@
 	
 	function get_dropdown_contacts(){
-		
-		$contacts = $this -> get_cc_contacts();
-		$groups = $this -> get_cc_groups();
+		$contacts = $this->get_cc_contacts();
+		$groups = $this->get_cc_groups();
 		
 		if(($contacts) && ($groups))
@@ -223,6 +222,5 @@
 			$stringDropDownContacts = $groups;
 					
-		if($_SESSION['phpgw_info']['user']['preferences']['expressoMail']['number_of_contacts'] &&
-			$_SESSION['phpgw_info']['user']['preferences']['expressoMail']['use_dynamic_contacts']) {
+		if($_SESSION['phpgw_info']['user']['preferences']['expressoMail']['use_dynamic_contacts']) {
 			// Free others requests 
                         session_write_close(); 
@@ -270,7 +268,5 @@
 	{				
 		// Pesquisa os emails e ultima inserção nos contatos dinamicos.
- 		if(!$this->db->select('phpgw_expressomail_contacts','data',
-						  'id_owner ='.$this -> user_id,
-						  __LINE__,__FILE__))
+ 		if(!$this->db->select('phpgw_expressomail_contacts','data','id_owner ='.$this->user_id,__LINE__,__FILE__))
 		{
         	return $this->db->Error;
@@ -295,8 +291,29 @@
 	function update_contacts($contacts=array())
 	{			
+		
+	
+		if(!$this->db->select('phpgw_expressomail_contacts','data','id_owner ='.$this->user_id,__LINE__,__FILE__))
+        {
+            $result['dberr1'] = $this->db->Error;
+        }
+		$regs = array();
+		while($this->db->next_record())
+        {
+            $regs[] = $this->db->row();
+        }
+		$old_contatacts = array();
+		foreach($regs as $old){
+			$old_contatacts = unserialize($old['data']);
+		}
+		 
+		foreach($old_contatacts as $i => $v)
+			foreach($contacts as $ii => $vv)
+				if(trim($v['email']) == trim($vv['email']))
+					unset($old_contatacts[$i]);
+		
+		 
+		 $old_contatacts = array_merge( $old_contatacts , $contacts);		
 		// Atualiza um email nos contatos dinamicos.
-		if(!$this->db->update('phpgw_expressomail_contacts ','data=\''.serialize($contacts).'\'',
-			'id_owner ='.$this -> user_id,
-			__LINE__,__FILE__))
+		if(!$this->db->update('phpgw_expressomail_contacts ','data=\''.serialize($old_contatacts).'\'','id_owner ='.$this->user_id,__LINE__,__FILE__))
 		{
 			return $this->db->Error;
@@ -344,31 +361,43 @@
 		$msg_part = $params['msg_part'];
 		$msg_folder = $params['msg_folder'];
+            $from_ajax = $params['from_ajax'];
 		$encoding = strtolower($params['encoding']);
 		$fileContent = "";
-
-		if($msg_number && $msg_part && $msg_folder && (intval($idx_file == '0' ? '1' : $idx_file))) {
-			$mbox_stream = $objImap->open_mbox($msg_folder);   	
-			$fileContent = imap_fetchbody($mbox_stream, $msg_number, $msg_part, FT_UID);
-			include_once('class.imap_attachment.inc.php');
-			$imap_attachment = new imap_attachment();
-			$a = $imap_attachment->download_attachment($mbox_stream, $msg_number);
-			$filename = $a[$idx_file]['name'];
+            $cirus_delimiter = $params['cirus_delimiter'];
+            $expFolder = explode($cirus_delimiter, $msg_folder);
+
+            if($msg_number != null && $msg_part != null && $msg_folder != null && (intval($idx_file == '0' ? '1' : $idx_file)))
+            {
+                require_once $_SESSION['rootPath'].'/expressoMail1_2/inc/class.attachment.inc.php';
+                $attachmentObj = new attachment();
+                $attachmentObj->setStructureFromMail($msg_folder,$msg_number);
+                $fileContent = $attachmentObj->getAttachment($msg_part);
+                $info = $attachmentObj->getAttachmentInfo($msg_part);
+                $filename = $info['name'];
 		}
 		else
 			$filename = $idx_file;
 					
-		if($fileContent) {
-			if($encoding == 'base64')
-				$calendar = imap_base64($fileContent);
-			else if($encoding == 'quoted-printable')
-				$calendar = quoted_printable_decode($fileContent);
-			else
-				$calendar = $fileContent;
-		}
 		// It's necessary to access calendar method. 
+            $GLOBALS['phpgw_info']['flags']['noappheader'] = True;
+            $GLOBALS['phpgw_info']['flags']['noappfooter'] = True;
+            $GLOBALS['phpgw_info']['flags']['currentapp'] = 'calendar';
 		include_once(PHPGW_INCLUDE_ROOT.'/header.inc.php'); 
-			
 		$uiicalendar = CreateObject("calendar.uiicalendar");
-		return $uiicalendar = $uiicalendar->import_from_mail($calendar);
+
+            if(strtoupper($expFolder[0]) == 'USER' && $expFolder[1]) // IF se a conta o ical estiver em uma conta compartilhada
+            {
+                include_once('class.ldap_functions.inc.php');
+                $ldap = new ldap_functions();
+                $account['uid'] = $expFolder[1];
+                $account['uidnumber']  = $ldap->uid2uidnumber($expFolder[1]);
+                $account['mail']  = $ldap->getMailByUid($expFolder[1]);
+
+                return $uiicalendar->import_from_mail($fileContent, $from_ajax,$account);
+            }
+            else
+                return $uiicalendar->import_from_mail($fileContent, $from_ajax);
+            
+            
 	}
 
@@ -439,4 +468,144 @@
 	}
 
+	
+	/**
+     * @abstract Recupera o valor da regra padrão.
+     * @return retorna o valor da regra padrão.
+     */
+	function get_default_max_size_rule()
+	{
+		$query = "SELECT config_value FROM phpgw_config WHERE config_name = 'expressoAdmin_default_max_size'";
+		if(!$this->db->query($query))
+            return false;
+
+        $return = array();
+			
+		while($this->db->next_record())
+            array_push($return, $this->db->row());
+			
+		return $return;
+	}
+	
+	/**
+     * @abstract Recupera a regra de um usuário.
+     * @return retorna a regra que o usuário pertence. Caso o usuário não participe de nenhuma regra, retorna false.
+     */
+	function get_rule_by_user($id_user) 
+	{
+		$return = array();	
+		$query = "SELECT email_max_recipient FROM phpgw_expressoadmin_configuration WHERE email_user='$id_user' AND configuration_type='MessageMaxSize'";
+		
+		if(!$this->db->query($query))
+            return false;
+		
+		while($this->db->next_record())
+            array_push($return, $this->db->row());
+			
+		return $return;
+	}
+	
+	
+	function get_rule_by_user_in_groups($id_group)
+	{
+		$return = array();
+		$query = "SELECT email_max_recipient FROM phpgw_expressoadmin_configuration WHERE configuration_type='MessageMaxSize' AND email_user_type='G' AND email_user='".$id_group."'";
+
+		if(!$this->db->query($query))	
+			return false;	
+			
+		while($this->db->next_record())
+			array_push($return, $this->db->row());
+
+		return $return; 
+	}
+        function getMaximumRecipientsUser($pUserUID)
+        {
+
+           $query = 'SELECT email_max_recipient FROM phpgw_expressoadmin_configuration WHERE email_user = \''.$pUserUID.'\' AND configuration_type = \'LimitRecipient\' AND email_user_type = \'U\' ';
+           $this->db->query($query);
+
+           $return = array();
+
+            while($this->db->next_record())
+              $return =  $this->db->row();
+
+            return $return['email_max_recipient'];
+        }
+
+        function getMaximumRecipientsGroup($pGroupsGuidnumbers)
+        {
+           $groupsGuidNumbers = '';
+
+           foreach ($pGroupsGuidnumbers as $guidNumber => $cn)
+             $groupsGuidNumbers .= $guidNumber.', ';
+
+           $groupsGuidNumbers = substr($groupsGuidNumbers,0,-2);
+
+           $query = 'SELECT email_max_recipient FROM phpgw_expressoadmin_configuration WHERE email_user IN ('.$groupsGuidNumbers.') AND configuration_type = \'LimitRecipient\' AND email_user_type = \'G\' ';
+           $this->db->query($query);
+
+           $return = array();
+
+            while($this->db->next_record())
+              $return[] =  $this->db->row();
+
+            $maxSenderReturn = 0;
+
+            foreach ($return as $maxSender)
+            {
+                if($maxSender['email_max_recipient'] > $maxSenderReturn)
+                    $maxSenderReturn = $maxSender['email_max_recipient'];
+            }
+
+            return $maxSenderReturn;
+        }
+
+	function validadeSharedAccounts($user,$grups,$accountsMails)
+        {
+
+             $arrayMailsBlocked = array();
+
+             $query = 'SELECT * FROM phpgw_expressoadmin_configuration WHERE email_user = \''.$user.'\' AND email_recipient = \'*\'  AND configuration_type = \'InstitutionalAccountException\' AND email_user_type = \'U\' ';
+             $this->db->query($query);
+             $this->db->next_record();
+                 if($this->db->row())
+                   return $arrayMailsBlocked;
+
+            foreach ($grups as $guidNumber => $cn)
+            {
+                 $query = 'SELECT * FROM phpgw_expressoadmin_configuration WHERE email_user = \''.$guidNumber.'\' AND email_recipient = \'*\'  AND configuration_type = \'InstitutionalAccountException\' AND email_user_type = \'G\' ';
+                 $this->db->query($query);
+                 $this->db->next_record();
+                 if($this->db->row())
+                     return $arrayMailsBlocked;
+
+            }
+
+            foreach ($accountsMails as $mail)
+            {
+               
+               $blocked = true;
+
+               $query = 'SELECT * FROM phpgw_expressoadmin_configuration WHERE email_recipient = \''.$mail.'\' AND configuration_type = \'InstitutionalAccountException\' ';
+               $this->db->query($query);
+           
+                while($this->db->next_record())
+                {
+                    $row =  $this->db->row();
+                    
+                    if(($row['email_user'] == '*' ||  $row['email_user'] == $user) && ($row['email_user_type'] == 'T' || $row['email_user_type'] == 'U'))
+                        $blocked = false;
+                    else if(array_key_exists($row['email_user'], $grups) && $row['email_user_type'] == 'G')
+                         $blocked = false; 
+
+                }
+
+                if($blocked == true)
+                    array_push ($arrayMailsBlocked, $mail);
+            }
+
+            return $arrayMailsBlocked;
+        }
+
 }
 ?>
